<script type="text/javascript" src="/js/cubix-ui-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-button-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-shadow-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-popup-v3.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-grid-v2.0.source.js"></script>

<script type="text/javascript" src="/js/datepicker.js"></script>

<script type="text/javascript">
Cubix.ready = function () {
	new Cubix.Shadow($('content'));

	var getFilterParams = function () {
		var uri = new URI('?' + $$('form')[0].toQueryString());
		return uri.get('data');
	};
	
	var popup = new Cubix.Popup.Ajax({
		abar: [
			{ caption: 'Save', icon: 'accept', action: Cubix.Popup.Actions.SaveValid },
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 400
	});
	
	var grid = Cubix.Grid.Instance = new Cubix.Grid('cx-grid', {
		identifier: { field: 'id' },
		header: [
			{ title: '<input type="checkbox" id="select-all" />', field: '', type: 'Checkbox', width: '15px' },
			{ title: 'Email', field: 'email', type: 'string', sortable: true },
			{ title: 'Name', field: 'name', type: 'string', sortable: true },
			{ title: 'Group', field: 'group_title', type: 'string' },
			{ title: 'Registration Date', field: 'reg_date', type: 'DateTime', sortable: true, width: '160px' },
			{ title: 'Status', field: 'status', type: 'ToggleButton', sortable: true, width: '60px' },
		],
		sort: {
			field: 'reg_date',
			dir: 'desc'
		},
		actions: [ { type: 'remove', func: function (data) {
			if ( confirm('Are you sure you want to delete this entity ?') ) {
				this.overlay.disable();
				new Request({
					url: '/newsletter/subscribers/delete?id=' + data.id,
					onSuccess: function (resp) {
						grid.load();
					}.bind(this)
				}).send();
			}
		} }, { type: 'edit', func: function (data) {
			popup.setTitle('Edit Newsletter Subscriber');
			popup.load('/newsletter/subscribers/edit?id=' + data.id, function () {
				this.open();
			});
		} } ],
		data: new Cubix.Grid.Loader({ url: '/newsletter/subscribers/data', params: getFilterParams })
	});
	
	grid.addEvent('loaded', function () {
	
		$$('.cx-grid-type-ToggleButton a').addEvent('click', function (e) {
			e.stop();
			
			new Request({
				url: this.get('href'),
				method: 'get',
				onSuccess: function(){
					grid.load();
				}
			}).send();
		});

		$('select-all').set('checked', '');

		$('select-all').addEvent('click', function() {
			if ( this.get('checked') )
			{
				$$('table input[type=checkbox]').each(function(it){
					if ( it.get('id') != 'select-all' )
						it.set('checked', 'checked');
				});
			}
			else
			{
				$$('table input[type=checkbox]').each(function(it){
					if ( it.get('id') != 'select-all' )
						it.set('checked', '');
				});
			}
		});
	});

	new Cubix.Button($('btn-create'), { onClick: function () {
		popup.setTitle('Add Newsletter Subscriber');
		popup.load('/newsletter/subscribers/create', function () {
			this.open();
		});
	}, icon: 'add', caption: 'Add Subscriber', classes: 'mr10' });

	var ex_popup = new Cubix.Popup.Ajax({
		abar: [
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 490
	});

	new Cubix.Button($('btn-export'), { onClick: function () {
		ex_popup.setTitle('Export Subscribers Email List');
		ex_popup.load('/newsletter/subscribers/export', function () {
			this.open();
		});
	}, icon: 'unread', caption: 'Export Email List', classes: 'mr10' });

	var im_popup = new Cubix.Popup.Ajax({
		abar: [
			{ caption: 'Import', icon: 'msg_add', action: Cubix.Popup.Actions.SaveValid },
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 490
	});

	new Cubix.Button($('btn-import'), { onClick: function () {
		im_popup.setTitle('Import Subscribers Emails');
		im_popup.load('/newsletter/subscribers/import', function () {
			this.open();
		});
	}, icon: 'msg_add', caption: 'Import Emails', classes: 'mr10' });

	new Cubix.Button($('btn-delete'), { onClick: function () {
		var ids = getCheckedIds();

		if ( ids )
		{
			if ( confirm('Are you sure you want to delete selected subscriber(s)?') ) {

				new Request({
					url: '/newsletter/subscribers/delete-checked',
					data: ids,
					onSuccess: function (resp) {
						grid.load();
					}.bind(this)
				}).send();
			}
		}
		else
		{
			alert('Please select some subscriber(s) to perform action with !');
		}
	}, icon: 'msg_remove', caption: 'Delete Selected', classes: 'mr10' });

	function getCheckedIds()
	{
		var ids = '';
		$$('table input[type=checkbox]').each(function(it){
			if ( it.get('id') != 'select-all' && it.get('checked') )
				ids += 'id[]=' + it.value + '&';
		});

		return ids;
	}

	new Cubix.Button($('btn-refresh'), { onClick: function () {
		grid.load();
	}, icon: 'refresh', caption: 'Search', classes: 'ml396' });

	window.addEvent('domready', function() {
		new Picker.Date('input[name=date_from]', { pickerClass: 'datepicker',
			positionOffset: { x: -10, y: 0 }, allowEmpty: true, format: 'd M Y' });
		new Picker.Date('input[name=date_to]', { pickerClass: 'datepicker',
			positionOffset: { x: -10, y: 0 }, allowEmpty: true, format: 'd M Y' });
	});

	var initFormSubmit = function() {
		var inputs = $$('.form-common')[0].getElements('input');

		inputs.each(function(input) {
			var input_type = input.get('type');

			if ( input_type != 'hidden' ) {
				if ( input_type == 'text' ) {
					input.addEvent('keyup', function(event) {
						if( event.key == 'enter' ) {
							grid.load();
						}
					});
				}
				else {
					input.addEvent('change', function(){
						grid.load();
					});
				}
			}
		});

		var selects = $$('.form-common')[0].getElements('select');

		selects.addEvent('change', function(){
			grid.load();
		});
	};

	initFormSubmit();
};
</script>

<div class="form-common gray">
	<form>
		<fieldset class="inner mb10">
			<div class="inner">
				<label for="f-email">Email / Name</label>
				<input id="f-email" type="text" class="txt w18" name="email" value="" />
			</div>

			<div class="inner">
				<label for="f-status">Show</label>
				<select name="status" id="f-status">
					<option value="">--- All ---&nbsp;&nbsp;</option>
					<option value="1">Actives</option>
					<option value="0">Passives</option>
				</select>
			</div>

			<div class="inner">
				<label for="f-groups">Groups</label>
				<select name="group" id="f-groups">
					<option value="">--- All Groups ---&nbsp;&nbsp;</option>
					<?php foreach ($this->groups as $group):?>
						<option value="<?= $group->id ?>"><?= $group->group_title ?></option>
					<?php endforeach; ?>
				</select>
			</div>

			<div class="clear"></div>

			<div class="inner mb10">
				<label for="f-date-from">Date From</label>
				<input id="f-date-from" type="text" class="txt w14" name="date_from" value="" />
			</div>
			<div class="inner" style="padding-top:27px">
			-
			</div>
			<div class="inner mb10">
				<label for="f-date-to">Date To</label>
				<input id="f-date-to" type="text" class="txt w14" name="date_to" value="" />
			</div>

			<div class="clear"></div>
		</fieldset>

		<div class="clear"></div>
		<a id="btn-refresh"></a>
		<div class="clear"></div>
	</form>
</div><!-- form-common -->

<div class="action-bar" style="margin-top: 20px;">
	<a href="" id="btn-create"></a>
	<a href="" id='btn-delete'></a>
	<a href="" id="btn-export"></a>
	<a href="" id="btn-import"></a>
	
	<div class="clear"></div>
</div>

<div id="ajax-dest">
	<div id="cx-grid">
	</div>
</div>
